import { CommandContext, CommandOptionType, SlashCommand, SlashCreator } from 'slash-create'

const things: Record<string, string> = {
  'gm': 'good morning',
  'ga': 'good afternoon',
  'gn': 'good night'
}

export default class RPSCommand extends SlashCommand {
  constructor(creator: SlashCreator) {
    super(creator, {
      name: 'g',
      description: 'gmgnga',
      options: [
        {
          name: 'type',
          description: 'type of gmgnga',
          type: CommandOptionType.STRING,
          choices: [
            { name: 'gm', value: 'gm' },
            { name: 'ga', value: 'ga' },
            { name: 'gn', value: 'gn' }
          ],
          required: true
        },
        {
          name: 'who',
          description: 'who to gmgnga (optional)',
          type: CommandOptionType.USER,
          required: false
        }
      ]
    })
  }

  async run(ctx: CommandContext) {
    if (ctx.options.who == null) {
      return `<@${ctx.member?.id}> says ${things[ctx.options.type as 'gm' | 'gn' | 'ga']}`
    } else {
      return `<@${ctx.member?.id}> says ${things[ctx.options.type as 'gm' | 'gn' | 'ga']} to <@${ctx.options.who}>`
    }
  }
}
